import 'package:code_id_network/code_id_network.dart';
import 'package:code_id_storage/code_id_storage.dart';

typedef AuthTokenBuilder = Map<String, dynamic>? Function(dynamic token);

class AuthInterceptor extends Interceptor {
  // final String? token;
  final IStorage storage;
  final String authKey;
  final AuthTokenBuilder authHeadersBuilder;

  // final String
  AuthInterceptor({
    required this.storage,
    required this.authKey,
    required this.authHeadersBuilder,
  });

  @override
  Future<void> onRequest(
    RequestOptions options,
    RequestInterceptorHandler handler,
  ) async {
    if (storage.isOpen()) {
      final token = storage.getData(key: authKey);

      final Map<String, dynamic>? authHeader = authHeadersBuilder(token);
      if (authHeader != null) {
        options.headers.addAll(authHeader);
      }
    }

    super.onRequest(options, handler);
  }
}
